/************************************************************
common.h

Holds common definitions across all the modules.
************************************************************/

#pragma once

//Error codes; common across all modules
typedef enum _status_t
{
	SUCCESS,
	TIMEOUT,
	INVALID_ROWS,
	INVALID_COLS,
	EMPTY_FRAME,
	OUT_OF_RANGE,
	MISC_ERROR
}status_t;

//Define largest possible frame sizes. Used in error checking.
#define MAX_COLS_POSSIBLE	720
#define MAX_ROWS_POSSIBLE	480

#define GETBUF(Q, BUF, TIME) { \
									do\
									{\
										error = this->Q->dequeue((void**)&BUF, TIME);\
									}while(TIMEOUT == error && this->keep_running);\
								}
