#pragma once

#define DEFAULT_COMPOSITOR_ALPHA  95

typedef enum 
{
	COMP_CALIBRATE,
	COMP_TRACK
}compositor_modes_t;

class compositor
{
private:

	queue_t	*in_scene;
	queue_t	*in_eye_coords;

	Point   last_eye_point;
	Point	last_scene_point;

	Point	eye_offset;
	Point2f	scale;
	Point	scene_offset;

	Point	tracked_eye;

	compositor_modes_t	mode;

	bool	calibrate_now;

	HANDLE	h_thread;
	DWORD	thread_id;
	bool	keep_running;

	char  session_name[500];

	FILE	*text_file;
	VideoWriter	*video_file;

	status_t calibrate(Mat *ps_frame, Point *ps_eye, Point bright_point);
	status_t track(Mat *ps_frame, Point *ps_eye, Point **pps_gaze, int alpha);

public:
	compositor(char* session_name, queue_t *in_scene, queue_t *in_eye_coords);
	~compositor(void);
	status_t process();

	status_t set_mode(compositor_modes_t mode);
	status_t calibrate_on_next_frame();
};

