#pragma once


//Multiplicaation factor used to filter out based on length and breadth.
#define MULT_FACTOR		2

//Factor used to figure out what elements are too small, based on area
#define AREA_FACTOR		9

//Orientation threshold. In degrees. Found by trial-and-error.
//Can be a float.
//Any blob with orientation greater than this value is rejected. Eye has orienation ~ 180.
#define ANGLE_THRESH	225

//Smoothing factor
#define ALPHA	(0.90)

class eye_window_detector
{
private:
	int h;
	int w;

	queue_t* in_original;
	queue_t* in_segmented;
	queue_t* out_original;
	queue_t* out_coords;
	
	queue_t* in_scene;
	queue_t* out_scene;

	HANDLE	h_thread;
	DWORD	thread_id;
	bool	keep_running;

	//Last coordinates calculated for the window.
	Point	last_coords;

public:
	eye_window_detector(  int eye_window_h, 
						int eye_window_w, 
						queue_t* in_original,
						queue_t* in_segmented,
						queue_t* in_scene,
						queue_t* out_original,
						queue_t* out_processed,
						queue_t* out_scene);
	~eye_window_detector(void);

	status_t	process();
};

