/******************************************************************************
queue.h: Implementation of a FIFO queue. To be used to pass objects, usually 
		   Mat objects, between threads in the auto-eye-tracker system.
******************************************************************************/

#pragma once

#define MAX_Q_LENGTH	5

class queue_t
{
private:
	//Array of objects.
	void*	obj_array[MAX_Q_LENGTH];

	//Read and write pointers
	int		read;
	int		write;

	//Count of elements in the queue.
	int		length;

	//Lock to be used while reading or writing to this queue.
	HANDLE	lock;

	//semaphores used to signal producers and consumers.
	HANDLE	space_present;
	HANDLE	objects_present;

public:
	//Enqueue and de-queue parameters.
	status_t enqueue(void *object, int timeout);
	status_t dequeue(void** p_object, int timeout);

	//Constructor and destructor.
	queue_t();
	~queue_t();
};