/********************************************************
video_capture.h

Header file for the video capture class.
********************************************************/
#pragma once

#define FRAME_PERIOD 33	//in milliseconds



using namespace cv;

class video_capture
{
private:
	int				camera_id;
	
	VideoCapture*	h_cap;

	HANDLE			h_thread;
	DWORD			thread_id;

	//Semaphore to signal start of capture.
	HANDLE			start_sem;
	bool			keep_running;

	//Output queue
	queue_t*		output_q;

	//Just to draw a box
	int h;
	int w;

public:
	video_capture(int camera_id, int w, int h);
	~video_capture(void);
	status_t start();
	status_t set_output_queue(queue_t* q);
	status_t process();
	
};

