// queue_test.cpp : Defines the entry point for the console application.
//

#include <iostream>
#include <windows.h>

#include "stdafx.h"
#include "common.h"
#include "queue.h"

using namespace std;

int	keep_running;

DWORD WINAPI writer(LPVOID pv_params);
DWORD WINAPI reader(LPVOID pv_params);

int _tmain(int argc, _TCHAR* argv[])
{
	DWORD reader_id, writer_id;
	HANDLE h_reader, h_writer;
	queue_t		*ps_queue = new queue_t;

	keep_running = 1;
	cout << "Creating thread 1...\n";
	h_reader = CreateThread(NULL,                   // default security attributes
							0,                      // use default stack size  
							writer,       // thread function name
							ps_queue,          // argument to thread function 
							0,                      // use default creation flags 
							&writer_id);   // returns the thread identifier 

	cout << "Creating thread 2...\n";
	h_writer = CreateThread(NULL,                   // default security attributes
							0,                      // use default stack size  
							reader,       // thread function name
							ps_queue,          // argument to thread function 
							0,                      // use default creation flags 
							&reader_id);   // returns the thread identifier 
	
	cout << "Hit ENTER to quit\n";
	getchar();

	keep_running = 0;

	cout << "Waiting for writer to complete...\n";
	WaitForSingleObject(h_writer,INFINITE);

	cout << "Waiting for reader to complete...\n";
	WaitForSingleObject(h_reader,INFINITE);
	
	return 0;
}


DWORD WINAPI writer(LPVOID pv_params)
{
	queue_t *ps_queue = (queue_t*)pv_params;
	int count = 0;
	int *num;
	int error;
	
	while(keep_running)
	{
		num = new int;

		cout << "Inserting " << count << endl;

		*num = count++;

		//Insert an element into the queue.

		error = ps_queue->enqueue(num, 50);
		if( error == TIMEOUT)
		{
			cout << "Insert timed out\n";
			continue;
		}

		cout << "Inserted " << count << endl;

		//sleep for a while
		Sleep(100);
	}

	return 0;
}


DWORD WINAPI reader(LPVOID pv_params)
{
	queue_t *ps_queue = (queue_t*)pv_params;
	int count = 0;
	int *num;
	int error;
	
	while(keep_running)
	{
		cout << "Extracting... " << endl;

		//Insert an element into the queue.
		error = ps_queue->dequeue((void**)&num, 100);

		if( TIMEOUT == error )
		{
			cout << "Timed out\n";
		}
		else
		{
			cout << "Extracted " << *num << endl;
		}

		

		//sleep for a while
		Sleep(1000);
	}

	return 0;
}